/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fxlib.h"
#include "TIMER_FX2.H"
#include "KeyScan.H"
#include "FKey.H"

//------------------------------------------------------------------------------

int FuncKeyDown()	// no key down : 0
{
	if ( *(volatile unsigned short*)0xFFFFFF80 != 0 ) 
	 return ( *((unsigned char*)0xA4000120) != 0xFF );		// SH3
	 return ( *((unsigned short*)0xA44b0008) != 0 );		// SH4A
}
//------------------------------------------------------------------------------
int KeyCheckEXIT(void)		// [EXIT]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 8 ) ) flag0=1; // [EXIT] is down
	}
	return flag0;
}

int KeyCheckDEL(void)		// [DEL]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 5 ) ) flag0=1; // [DEL] is down
	}
	return flag0;
}

int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
	return flag0;
}

int KeyCheckAC_Fast(void)		// [AC]
{
 	return ( KeyScanDown(KEYSC_AC) );
}


int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
	return flag0;
}

int KeyCheckEXE_Fast(void)		// [EXE]
{
 	return ( KeyScanDown(KEYSC_EXE) );
}


//------------------------------------------------------------------------------

int prevX=63, prevY=31 ;	// previous XY
int nowX= 63, nowY= 31 ;	// current

void PlotOn_VRAM(x, y){
	Bdisp_SetPoint_VRAM(x, 63-y, 1);
}
void PlotOn_DD(x, y){
	PlotOn_VRAM(x, y);
	Bdisp_PutDisp_DD();
}
void PlotOff_VRAM(x, y){
	Bdisp_SetPoint_VRAM(x, 63-y, 0);
}
void PlotOff_DD(x, y){
	PlotOff_VRAM(x, y);
	Bdisp_PutDisp_DD();
}
void PlotChg_VRAM(x, y){
	if ( Bdisp_GetPoint_VRAM(x, 63-y) )
		 Bdisp_SetPoint_VRAM(x, 63-y, 0);
	else Bdisp_SetPoint_VRAM(x, 63-y, 1);
}
void PlotChg_DD(x, y){
	PlotChg_VRAM(x, y);
	Bdisp_PutDisp_DD();
}
void PxlOn_VRAM(y, x){
	Bdisp_SetPoint_VRAM(x, y, 1);
}
void PxlOn_DD(y, x){
	Bdisp_SetPoint_VRAM(x, y, 1);
	Bdisp_PutDisp_DD();
}
void PxlOff_VRAM(y, x){
	Bdisp_SetPoint_VRAM(x, y, 0);
}
void PxlOff_DD(y, x){
	Bdisp_SetPoint_VRAM(x, y, 0);
	Bdisp_PutDisp_DD();
}
int PxlTest(y, x) {
	return	Bdisp_GetPoint_VRAM(x, y);
}
//------------------------------------------------------------------------------

void DrawGCSR( int x, int y )
{
	const char PlotCsrDATA[]={ 0x1C,0x14,0x77,0x41,0x77,0x14,0x1C };
	const char PlotCsrMASK[]={ 0x1C,0x1C,0x7F,0x7F,0x7F,0x1C,0x1C };

    DISPGRAPH GCSR; 
    
    GCSR.x = x-4; 
    GCSR.y = y-3; 
    GCSR.GraphData.width =  8; 
    GCSR.GraphData.height = 7;
    
    GCSR.GraphData.pBitmap = PlotCsrMASK; 	// mask pattern
    GCSR.WriteModify = IMB_WRITEMODIFY_NORMAL; 
    GCSR.WriteKind = IMB_WRITEKIND_OR;
    Bdisp_WriteGraph_DDVRAM(&GCSR);
    
    GCSR.WriteKind = IMB_WRITEKIND_XOR;
    Bdisp_WriteGraph_DDVRAM(&GCSR);
    
    GCSR.GraphData.pBitmap = PlotCsrDATA; 	// cursor pattern
    GCSR.WriteModify = IMB_WRITEMODIFY_NORMAL; 
    GCSR.WriteKind = IMB_WRITEKIND_OR;
    Bdisp_WriteGraph_DDVRAM(&GCSR); 
    
	PxlOn_DD(y,x);							// center dot
}

void Plot(int x, int y)
{
	int j=0, s,t,cont=1;
	char buffer[21];
	unsigned int key;
	
	long FirstCount;	 // pointer to repeat time of first repeat
	long NextCount; 	// pointer to repeat time of second repeat
	
	Bkey_Get_RepeatTime(&FirstCount,&NextCount);	// repeat time
	Bkey_Set_RepeatTime(FirstCount,2);				// graphic cursor repeat time set  (count * 25ms)

	SaveDisp(SAVEDISP_PAGE1);	// ------ SaveDisp1
	while (cont) {
			
		RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
		SaveDisp(SAVEDISP_PAGE1);		// ------ SaveDisp1
		sprintf(buffer, "X=%d", x);	PrintMini(  0,58,(unsigned char*)buffer,0);
		sprintf(buffer, "Y=%d", y);	PrintMini( 64,58,(unsigned char*)buffer,0);
		DrawGCSR(x+1,63-y); 	// graphic cursor
		Bdisp_PutDisp_DD();
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_LEFT:
				if (x>0) x-=1;
				break;
			case KEY_CTRL_RIGHT:
				if (x<126) x+=1;
				break;
			case KEY_CTRL_UP:
				if (y<62) y+=1;
				break;
			case KEY_CTRL_DOWN:
				if (y>0) y-=1;
				break;
			default:
				break;
		}
	}
	Bkey_Set_RepeatTime(FirstCount,NextCount);	// restore repeat time
	RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
	PxlOn_DD(63-y, x+1);
	nowX=x; nowY=y;
}

void Line(void) {
	if (prevX<0) { prevX=nowX; prevY=nowY; return; }
	Bdisp_DrawLineVRAM(  prevX+1, 63-prevY, nowX+1, 63-nowY);
	prevX=nowX; prevY=nowY;
}



//------------------------------------------------------------------------------
#define		wAry 32

void BugTrap(int flag)
{
	char minimsg[]={'E','X','E','/',0xE6,0x91,'/',0xE6,0x92,'/',0xE6,0x90,'/',0xE6,0x93,':',' ','D','r','a','w',' ','W','a','l','l',0};
	char buffer[21];
	unsigned int key;
	int B,A,D,C;
	int i,wX[wAry],wY[wAry];

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();
	for (i=0; i<wAry ; i++) {
		wX[i]=0;
		wY[i]=0;
	}

	//==Draw frame==
	Bdisp_DrawLineVRAM(  1,  1, 127,  1);
	Bdisp_DrawLineVRAM(127,  1, 127, 63);
	Bdisp_DrawLineVRAM(  1, 63, 127, 63);
	Bdisp_DrawLineVRAM(  1,  1,   1, 63);

	
	//==Paint mode==
//	PrintMini(  3, 7, (unsigned char*)"EXE////: Draw Wall",0);
	PrintMini(  3, 7, (unsigned char*)minimsg,0);
	PrintMini(  3,13, (unsigned char*)"DEL:Go!",0);
	nowX=63;	nowY=31;
	prevX=-1;	prevY=-1;

	while (1) {
		GetKey(&key);
		if (key==KEY_CTRL_EXIT) break;
		if (key==KEY_CTRL_DEL) {
				while ( KeyCheckDEL() );
				break;
		}
		if (key==KEY_CTRL_EXE) {
			while ( KeyCheckEXE() ); 
			PrintMini(  3,13, (unsigned char*)"        ",0);
			Plot(nowX, nowY);
			Line();
			PrintMini(  3,13, (unsigned char*)"DEL:Go!",0);
		}
		if (key==KEY_CTRL_OPTN) {
			RestoreDisp(SAVEDISP_PAGE2);	// ------ RestoreDisp2
		}
	} 
	PrintMini(  3, 7, (unsigned char*)"                           ",0);
	PrintMini(  3,13, (unsigned char*)"        ",0);
	Bdisp_PutDisp_DD();

	//==Draw dot==
	B=62,A=2,D=-1,C=1;
	PxlOn_DD(B, A);
	
	//==Move dot==
	SaveDisp(SAVEDISP_PAGE1);	// ------ SaveDisp1
	SaveDisp(SAVEDISP_PAGE2);	// ------ SaveDisp2
	while (1) {
		//*Set direction
		RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
		if ( (B<=1) || (B>= 63) ) D=-D;
		else
		if ( (A<=1) || (A>=126) ) C=-C;
		else {
			if ( PxlTest(B+D,A) ) D=-D;
			if ( PxlTest(B,A+C) ) C=-C;
		}
		//*Plot dot
		B=B+D;
		A=A+C;
		
		if ( flag ){		// BugTrap only
			for (i=wAry-1; i>0 ; i--) {
				wX[i]=wX[i-1];
				wY[i]=wY[i-1];
			}
			wX[0]=A; wY[0]=B;
		}
		PxlOn_VRAM(B, A);
		if (flag) PxlOff_VRAM( wY[wAry-1], wX[wAry-1] );		// BugTrap only
		SaveDisp(SAVEDISP_PAGE1);		// ------ SaveDisp1

		Bdisp_DrawLineVRAM(124,  0, 127, 0);	// busy sign
		Bdisp_DrawLineVRAM(124,  1, 127, 1);
		Bdisp_DrawLineVRAM(124,  2, 127, 2);
		Bdisp_DrawLineVRAM(124,  3, 127, 3);
		
		Bdisp_PutDisp_DD();
		if ( KeyCheckEXIT() ) break;	// break;
	}

	RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
	if ( flag ){		// BugTrap only
		for (i=0; i<wAry ; i++) PxlOff_VRAM( wY[i], wX[i] );
	}
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}

//------------------------------------------------------------------------------
void DrunkBug()
{
	int j=0, s,t;
	int X=63,Y=31;
	char buffer[21];
	unsigned int key;

	int P,Q;

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();
	PrintMini(1,1,(unsigned char*)"EXE: Start",0);
	Bdisp_PutDisp_DD();
	while ( 1) {
		GetKey(&key);
		if (key==KEY_CTRL_EXE) {
			while ( KeyCheckEXE() );
			break;
		}
	}


	PrintMini(1,1,(unsigned char*)"EXIT: Quit    ",0);
	Bdisp_PutDisp_DD();

	while (1) {
		P=rand()*2/(RAND_MAX+1.0);
		Q=rand()*2/(RAND_MAX+1.0);

		if ( P ) {	if (X>=126) X-=2; 
					X+=1;
				}
		else {		if (X<=0) X+=2;
					X-=1;
			}
		if ( Q ) {	if (Y>=62) Y-=2; 
					Y+=1;
				}
		else {		if (Y<=0) Y+=2;
					Y-=1;
			}
			
		PlotChg_DD( X, Y);
		
		if ( KeyCheckEXIT() ) break;	// break;
	}
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		locate(1,1);Print((unsigned char*)"F1:Bug Trace");
		locate(1,2);Print((unsigned char*)"F2:Bug Trap");
		locate(1,3);Print((unsigned char*)"F3:Drunk Bug");
		
		locate(1,6);Print((unsigned char*)"F6:Recall Picture");

		Fkey_dispN( 0, "Trac");
		Fkey_dispN( 1, "Trap ");
		Fkey_dispN( 2, "Drk");
		
		Fkey_dispN( 5, "Rpic");
		
		GetKey(&key);
		switch (key) {
//			case KEY_CTRL_EXIT:
//				cont=0;
//				break;
				
			case KEY_CTRL_F1:
				BugTrap(0);
				break;
			case KEY_CTRL_F2:
				BugTrap(1);
				break;
			case KEY_CTRL_F3:
				DrunkBug();
				break;
			case KEY_CTRL_F6:
				RestoreDisp(SAVEDISP_PAGE3);	// ------ RestoreDisp3
				while (key!=KEY_CTRL_EXIT) GetKey(&key);
				break;
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

